Attribute VB_Name = "modUtilita"
Option Explicit
'
'--- SysSep: ---------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
(ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String _
, ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDECIMAL& = &HE
'
'--- Remove Menu: ---------------------------------------------------------
Private Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long _
, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "user32" (ByVal hWnd As Long _
, ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "user32" (ByVal hWnd As Long) As Long
'
Private Const MF_REMOVE = &H1000&
Private Const MF_ENABLED = &H0&
Private Const MF_INSERT = &H0&
'
Private Const SC_CLOSE = &HF060&
Private Const SC_MINIMIZE = &HF020&
Private Const SC_MAXIMIZE = &HF030&
Private Const SC_RESTORE = &HF120&

Public Sub CloseButtonDisable(ByVal frmF As Form)
'
'
    Dim R1&
'
    R1 = RemoveMenu(GetSystemMenu(frmF.hWnd, 0), SC_CLOSE, MF_REMOVE)
'
'
'
End Sub

Public Sub LeggiPosizioneForm(ByVal frmF As Form, ByRef frmF_Left&, ByRef frmF_Top& _
    , Optional ByRef frmF_Width&, Optional ByRef frmF_Height&)
'
'   Legge, se e' definito il "Product Name" del progetto, la posizione
'   iniziale e le dimensioni  del Form frmF memorizzate sul Registry di Window.
'   Da usare nell' evento frmF_Load:
'
    If App.ProductName <> "" Then
        frmF_Left = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Left", 0))
        frmF_Top = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Top", 0))
'
        frmF_Width = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Width", Screen.Width))
        frmF_Height = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Height", Screen.Height))
    Else
        frmF_Left = 0
        frmF_Top = 0
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
'
'
End Sub
Public Sub SalvaPosizioneForm(ByVal frmF As Form _
    , Optional ByVal Dimensioni As Boolean = False)
'
'   Salva, sul Registry di Window e se e' definito il
'   "Product Name" del progetto, la posizione finale
'   del Form frmF.  Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    If (frmF.WindowState <> vbMinimized) And (App.ProductName <> "") Then
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Left", frmF.Left
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Top", frmF.Top
'
        If Dimensioni Then
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Width", frmF.Width
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Function KAscNumInteri(ByVal KA% _
    , Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Public Function Quadro(ByVal Foglio As PictureBox _
    , ByVal X0!, ByVal Xn!, ByVal Y0!, ByVal Yn! _
    , Optional ByVal FormatVX$ = "#0.0##" _
    , Optional ByVal FormatVY$ = "#0.0##" _
    , Optional ByVal Npx& = 1, Optional PxN_X!, Optional PxN_Y! _
    , Optional ByVal Titolo$ = "" _
    , Optional ByVal UnitaX$ = "" _
    , Optional ByVal UnitaY$ = "" _
    , Optional ByVal AutoRed As Boolean = False) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Foglio:    PictureBox da scalare.
'    X0:        Valore minimo di ascissa da rappresentare.
'    Xn:        Valore massimo di ascissa da rappresentare.
'               Deve essere X0 < Xn.
'    Y0:        Valore minimo di ordinata da rappresentare.
'    Yn:        Valore massimo di ordinata da rappresentare.
'               Deve essere Y0 <= Yn.
'    FormatVX$: Stringa di formato dei valori sull' asse X.
'    FormatVY$: Stringa di formato dei valori sull' asse Y.
'    Npx:       N di Pixels di cui si vuole conoscere
'    PxN_X:      larghezza in [vbUser] e
'    PxN_Y:      altezza in [vbUser].
'    Titolo$:   Titolo del grafico.
'    UnitaX$:   Unita' (o titolo) dell' asse X.
'    UnitaY$:   Unita' (o titolo) dell' asse Y.
'    AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'
    Dim I&, Xi!, D_X!, rrx!, Yi!, D_Y!, rry!, Tx$
    Dim QxMin!, QxMax!, QyMin!, QyMax!, B0!, Bn!, TxW!
    Dim TitL!, TitT!, TitW!, TitH!, Po4_X!, Po4_Y!
    Const Log10! = 2.30258509299405 ' Log(10#)
    Const DYMin! = 0.0001           ' Ampiezza min. della scala Y.
'
    On Error GoTo Quadro_ERR
    ' Verifica la correttezza delle scale:
    If X0 >= Xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If Y0 > Yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
    ' Imposta i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = Xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, 3))
    Xn = rrx * Ceil(Round(Xn / rrx, 3))
    D_X = Xn - X0
'
    ' Imposta una scala minima
    ' per l' asse Y:
    If Yn - Y0 < DYMin Then
        Y0 = Y0 - DYMin / 2!
        Yn = Yn + DYMin / 2!
    End If
'
    ' Calcola la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = Yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, 3))
    Yn = rry * Ceil(Round(Yn / rry, 3))
    D_Y = Yn - Y0
'
    ' Il bordo a destra dipende dalla
    ' presenza, o meno, di un' etichetta:
    If UnitaX$ = "" Then
        Bn = D_X / 20!
    Else
        Bn = D_X / 10!
    End If
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxW = Foglio.TextWidth(Format$(Y0, FormatVY$) & " ")
    If TxW < Foglio.TextWidth(Format$(Yn, FormatVY$) & " ") Then
        TxW = Foglio.TextWidth(Format$(Yn, FormatVY$) & " ")
    End If
    B0 = TxW * (D_X + Bn) / (Foglio.ScaleWidth - TxW)
    If B0 < D_X / 10! Then B0 = D_X / 10!
'
    ' Imposta i bordi orizzontali
    ' e verticali:
    QxMin = X0 - B0
    QxMax = Xn + Bn
    QyMin = Y0 - D_Y / 10!
    QyMax = Yn + D_Y / 7!
'
    ' Cancella il Foglio e imposta la scala:
    Foglio.Picture = LoadPicture("")
    Foglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
    ' Calcola larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcola larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)
'
    Foglio.DrawMode = vbCopyPen
    Foglio.DrawWidth = 1
    Foglio.DrawStyle = vbDash
    Foglio.ForeColor = vbGreen
    ' Traccia la griglia verticale e scrive
    ' i valori dell' asse X:
    For Xi = X0 To Xn + 0.1 * rrx Step rrx
        Foglio.Line (Xi, Y0)-(Xi, Yn), vbGreen
        Tx$ = Format$(Xi, FormatVX$)
        Foglio.CurrentX = Xi - Foglio.TextWidth(Tx$) / 2!
        Foglio.CurrentY = Y0 - D_Y / 70!
        Foglio.Print Tx$;
    Next Xi
    ' Scrive l' etichetta dell' asse X:
    If UnitaX$ <> "" Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.Print UnitaX$;
    End If
    ' Traccia l' asse Y:
    If (X0 <= 0!) And (0! <= Xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, Y0)-(0!, QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(-Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
        Foglio.Line (0!, QyMax - D_Y / 30!) _
                   -(Po4_X / 2!, Po4_Y + QyMax - D_Y / 30!), vbGreen
    End If
'
    Foglio.DrawStyle = vbDash
    ' Traccia la griglia orizzontale e scrive
    ' i valori dell' asse Y:
    For Yi = Y0 To Yn + 0.1 * rry Step rry
        Foglio.Line (X0, Yi)-(Xn, Yi), vbGreen
        Tx$ = Format$(Yi, FormatVY$)
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = Yi - Foglio.TextHeight(Tx$) / 2!
        Foglio.Print Tx$;
    Next Yi
    ' Scrive l' etichetta dell' asse Y:
    If UnitaY$ <> "" Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QyMax
        Foglio.Print UnitaY$;
    End If
    ' Traccia l' asse X:
    If (Y0 <= 0!) And (0! <= Yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (X0, 0!)-(QxMax - D_X / 30!, 0!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, -Po4_Y / 2!), vbGreen
        Foglio.Line (QxMax - D_X / 30!, 0!) _
                   -(QxMax - D_X / 30! - Po4_X, Po4_Y / 2!), vbGreen
    End If
'
    ' Scrive il titolo del grafico:
    If Titolo$ <> "" Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifica che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglia:
        Else
            TitL = Foglio.ScaleLeft
            Tx$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Tx$)) / TitW)) & Tx$
        End If
        TitT = QyMax
        ' Cancella l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, Err.Source
    End If
'
'
'
End Function
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If X = Int(X) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Private Sub GetLocale(ByRef DS$, Optional ByRef MS$)
'
'   Trova i separatori decimale e
'   delle migliaia del sistema:
'
    DS$ = "  "
    MS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
'
'
'
End Sub

